# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

# If you don't want to build maven plugin
# give rpmbuild option '--without maven'

%define with_maven %{!?_without_maven:1}%{?_without_maven:0}
%define without_maven %{?_without_maven:1}%{!?_without_maven:0}

%define section         free
%define source_top      %{name}-%{cvs_version}

Summary:        XML-Java binding tool
URL:            http://xmlbeans.apache.org
Source0:        xmlbeans-2.1.0-src.tgz
# svn export http://svn.apache.org/repos/asf/xmlbeans/tags/2.1.0
Patch0:         xmlbeans-2.1.0-maven-plugin-project_xml.patch
Patch1:         xmlbeans-2.1.0-SchemaTypesTests.patch
Patch2:         xmlbeans-2.1.0-build_xml.patch
Patch3:         xmlbeans-2.1.0-XBeansXPath.patch
Patch4:         xmlbeans-2.1.0-XBeansXQuery.patch
Patch5:         xmlbeans-2.1.0-alltests.patch
Patch6:         xmlbeans-2.1.0-scripts.patch
Name:           xmlbeans
Version:        2.1.0
Release:        4jpp
Epoch:          0
License:        Apache Software License 2
Group:          Development/Libraries/Java
Vendor:         JPackage Project
Distribution:   JPackage
BuildRequires:  jpackage-utils >= 0:1.5
BuildRequires:  ant >= 0:1.6, ant-junit, ant-contrib, junit
%if %{with_maven}
BuildRequires:  maven >= 0:1.1
%endif
BuildRequires:  xml-commons-resolver >= 0:1.1
BuildRequires:  bea-stax-api
BuildRequires:  saxon8, saxon8-xpath
BuildRequires:  dom2-core-tests
Requires:       jpackage-utils >= 0:1.6
%if %{gcj_support}
BuildRequires:          gnu-crypto
BuildRequires:          java-gcj-compat-devel
Requires(post):         java-gcj-compat
Requires(postun):       java-gcj-compat
%endif
%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
XMLBeans is a tool that allows you to access the full power 
of XML in a Java friendly way. It is an XML-Java binding tool. 
The idea is that you can take advantage the richness and 
features of XML and XML Schema and have these features mapped 
as naturally as possible to the equivalent Java language and 
typing constructs. XMLBeans uses XML Schema to compile Java 
interfaces and classes that you can then use to access and 
modify XML instance data. Using XMLBeans is similar to using 
any other Java interface/class, you will see things like 
getFoo or setFoo just as you would expect when working with 
Java. While a major use of XMLBeans is to access your XML 
instance data with strongly typed Java classes there are also 
API's that allow you access to the full XML infoset (XMLBeans 
keeps full XML Infoset fidelity) as well as to allow you to 
reflect into the XML schema itself through an XML Schema 
Object model.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires(post):   /bin/rm,/bin/ln
Requires(postun): /bin/rm

%description javadoc
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.

%if %{with_maven}
%package maven-plugin
Summary:        Maven plugin for %{name}
Group:          Development/Build Tools
Requires:       %{name} >= 0:2.0
Requires:       maven >= 0:1.1
Requires:       bea-stax-api
Requires:       xml-commons-resolver

%description maven-plugin
%{summary}.
%endif

%package scripts
Summary:        Scripts for %{name}
Group:          Development/Tools
Requires:       %{name} = %{epoch}:%{version}

%description scripts
%{summary}.

%prep
%setup -q -n %{name}-%{version}
chmod -R go=u-w *
for j in $(find . -name "*.jar"); do
    jj=$(basename $j)
    m=$(expr $jj : '\(piccolo_apache_dist\).*') || :
    n=$(expr $jj : '\(jam-\).*') || :
    if [ "$m" != "piccolo_apache_dist" -a "$n" != "jam-" ]; then
       mv $j $j.no
    fi
done
mkdir -p build/lib
pushd build/lib
ln -sf $(build-classpath xml-commons-resolver) resolver.jar
ln -sf $(build-classpath bea-stax-api) jsr173_1.0_api.jar
popd

pushd external/lib
mv oldxbean.jar.no oldxbean.jar
popd

pushd test/lib
ln -sf $(build-classpath dom2-core-tests) w3c_domts.jar
popd

pushd test/tools/lib
ln -sf $(build-classpath junit) .
ln -sf $(build-classpath ant) .
ln -sf $(build-classpath ant/ant-junit) .
pushd ant-ext
ln -sf $(build-classpath ant-contrib) ant-contrib-0.6.jar
mkdir tmp
cd tmp
jar xf ../antexts.jar.no
rm -rf antexts* META-INF
cd src
javac -classpath $(build-classpath ant) $(find . -name "*.java")
jar cf ../../antexts.jar $(find . -name "*.class") antexts.properties
popd
popd

%patch0 -b .orig
%patch1 -b .orig
%patch2 -b .orig
%patch3 -b .orig
%patch4 -b .orig
%patch5 -b .orig
%patch6 -b .orig

%build
export XMLBEANS_EXTERNALS=/usr/share/java
export XMLBEANS_HOME=`pwd`
ant default docs testbuild
%if %{with_maven}
pushd maven-plugin
    maven -Dmaven.repo.remote=file:/usr/share/maven/repository jar:jar
popd
%endif
ant checkintest

%install
rm -rf $RPM_BUILD_ROOT

# jar
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -p -m 0644 build/lib/xmlpublic.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/xmlpublic-%{version}.jar
install -p -m 0644 build/lib/xbean_xpath.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/xbean_xpath-%{version}.jar
install -p -m 0644 build/lib/xbean.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/xbean-%{version}.jar
ln -s xmlpublic-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/xmlpublic.jar
ln -s xbean_xpath-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/xbean_xpath.jar
ln -s xbean-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/xbean.jar

install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
cp -pr xkit $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}

# bin
install -d -m 0755 $RPM_BUILD_ROOT%{_bindir}
install -p -m 0755 bin/dumpxsb   $RPM_BUILD_ROOT%{_bindir}
install -p -m 0755 bin/inst2xsd  $RPM_BUILD_ROOT%{_bindir}
install -p -m 0755 bin/scomp     $RPM_BUILD_ROOT%{_bindir}
install -p -m 0755 bin/sdownload $RPM_BUILD_ROOT%{_bindir}
install -p -m 0755 bin/sfactor   $RPM_BUILD_ROOT%{_bindir}
install -p -m 0755 bin/svalidate $RPM_BUILD_ROOT%{_bindir}
install -p -m 0755 bin/validate  $RPM_BUILD_ROOT%{_bindir}
install -p -m 0755 bin/xpretty   $RPM_BUILD_ROOT%{_bindir}
install -p -m 0755 bin/xsd2inst  $RPM_BUILD_ROOT%{_bindir}
install -p -m 0755 bin/xsdtree   $RPM_BUILD_ROOT%{_bindir}
install -p -m 0755 bin/xstc      $RPM_BUILD_ROOT%{_bindir}


# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr build/docs/reference/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink
rm -rf build/docs/reference

# manual
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr build/docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp LICENSE.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

%if %{with_maven}
# maven-plugin
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven/repository/JPP/plugins
cp -p maven-plugin/target/xmlbeans-maven-plugin-2.0.0-beta1.jar \
 $RPM_BUILD_ROOT%{_datadir}/maven/repository/JPP/plugins/maven-%{name}-plugin-%{version}.jar
ln -s maven-%{name}-plugin-%{version}.jar $RPM_BUILD_ROOT%{_datadir}/maven/repository/JPP/plugins/maven-%{name}-plugin.jar
%endif

%if %{gcj_support}
export CLASSPATH=$(build-classpath gnu-crypto)
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -sf %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%if %{gcj_support}
%post
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(-,root,root,-)
%{_docdir}/%{name}-%{version}/LICENSE.txt
%{_javadir}/*
%{_datadir}/%{name}-%{version}
%if %{gcj_support}
%attr(-,root,root) %dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/x*-%{version}.jar.*
%endif

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%{_docdir}/%{name}-%{version}

%if %{with_maven}
%files maven-plugin
%defattr(0644,root,root,0755)
%{_datadir}/maven/repository/JPP/plugins/maven-%{name}-plugin-%{version}.jar
%{_datadir}/maven/repository/JPP/plugins/maven-%{name}-plugin.jar
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/m*-%{version}.jar.*
%endif
%endif

%files scripts
%defattr(0644,root,root,0755)
%attr(0755,root,root) %{_bindir}/*


%changelog
* Thu Mar 01 2007 Ralph Apel <r.apel at r-apel.de> 0:2.1.0-4jpp
- Optionally omit build of maven plugin while bootstrapping

* Wed Sep 06 2006 Ralph Apel <r.apel at r-apel.de> 0:2.1.0-3jpp
- BuildRequire saxon8 instead of saxonb8
- (B)Require bea-stax-api instead of bea-stax
- Patch maven-plugin's project.xml for bea-stax-api instead of stax-bea-api
- Patch XbeanXQuery to saxon 8.7
- Add gcj_support option
- Add post/postun Requires for javadoc

* Wed Feb 01 2006 Ralph Apel <r.apel at r-apel.de> 0:2.1.0-2jpp
- Install plugin to /usr/share/maven/repository/JPP/plugins

* Mon Jan 30 2006 Ralph Apel <r.apel at r-apel.de> 0:2.1.0-1jpp
- Upgrade to 2.1.0
- Add -maven-plugin subpackage

* Fri Jun 03 2005 Fernando Nasser <fnasser@redhat.com> 0:1.0.4-2jpp
- Add missing build requires for jaxen

* Fri Jun 03 2005 Fernando Nasser <fnasser@redhat.com> 0:1.0.4-1jpp
- Upgrade to 1.0.4

* Thu Sep 30 2004 Ralph Apel <r.apel at r-apel.de> 0:1.0.3-1jpp
- First JPackage build 

